#ifndef __MD_LIB_FRACKER_H__
#define __MD_LIB_FRACKER_H__

#include <limits.h>
#include <string>
#include <MD/private/prefix.h>
#include <MD/MD_sys_types.h>

// The double needs to conform to IEEE 754
#ifdef MD_LIB_LINUX
#ifndef __STDC_IEC_559__
#error "Fracker requires IEEE 754 support (Linux)"
#endif
#endif

#ifdef MD_LIB_WIN
#if DBL_MANT_DIG != 53 || DBL_DIG != 15 || DBL_MAX_10_EXP != 308 || DBL_MIN_10_EXP != -307
#error "Fracker requires IEEE 754 support (Windows)"
#endif
#endif

namespace MD
{
  // use this to get the most precision
  MD_LIB_API int frac_double(double input, int64_t& whole, int64_t& num, int64_t& denom);

  // use this when you have to deal with 32 bit integers, for example when using w/n/d fields
  // in the MD_Message library.  You will only be able to get 9 digits of precision here.
  // returns number of decimal places if frac'ing was successful, returns - 1 otherwise
  MD_LIB_API int frac_double(double input, int32_t& whole, int32_t& num, int32_t& denom);

  MD_LIB_API std::string frac_double_to_string(const double input);
}

#endif // __MD_LIB_FRACKER_H__
